function [res] = thresh_image_percentile(in, perc)

    if isrgb(in)
        in = rgb2gray(in);
    end
    y = sort(reshape(in,size(in,1)*size(in,2),1));
    top = ceil((1.0-perc)*length(y));
    threshold = y(top);
    res = im2bw(in,threshold);
end