function [xmin,tfxmin] = optimizationWithSS(n_points, ...
    target, outer_shift_cart_op, movements_min, movements_max, movements_mean, penalties, generations, populationSize)

de_find(0,target,outer_shift_cart_op,movements_min, movements_max, movements_mean, penalties);
psoOptions.Vars.SwarmSize = populationSize; %80
psoOptions.Vars.Iterations = generations; %250
SSOptions.n_elems = n_points*2;
SSOptions.lb = 0;%zeros(1,n_points*2);
SSOptions.ub = 1;%ones(1,n_points*2);
SSOptions.refset_best_size = 7;
SSOptions.refset_diverse_size = 8;
SSOptions.population_size = (SSOptions.refset_diverse_size + SSOptions.refset_best_size) * 10;
SSOptions.max_num_reconstruction = 15;
SSOptions.n_parents = 2;
SSOptions.alpha_blx = 0.5;
SSOptions.max_evals = psoOptions.Vars.Iterations*psoOptions.Vars.SwarmSize;
SSOptions.max_iters = 500;
SSOptions.selection_method = 1;
SSOptions.local_search_method = 2;
SSOptions.save = 80;
[tfxmin,xmin, HistFDG]=ScatterSearch2(@(x)de_find(x),SSOptions);