function [tout1,Iorig] ...
    = readImageToRegister(SOURCE_FOLDER,image_name,show_output,imageMatrix)

tic
source_image_name = sprintf('%s/%s.jpg',SOURCE_FOLDER,image_name);
if ~exist(source_image_name,'file')% == false
    error(strcat('Source file (',image_name,'.jpg) is not in the correct folder (', SOURCE_FOLDER ,'). Elaboration stopped.'));
end
if show_output > 0
    fprintf(1,'Reading Input Image...\n');
end
if imageMatrix == 0
    try
        Iorig = cvReadImage(source_image_name,0);%rgb2gray(imread(source_image_name));
    catch
        Iorig = imread(source_image_name);
        disp('cvReadImage not available');
    end;
else
    Iorig = imageMatrix;
end;
tout1 = toc; % time: read input image