close all
clear all

% Read the image
Img = cvReadImage('images/simpleTest1.png');
%I = imresize(I, 0.5);
Img = fast_medfilt(uint8(Img),2);

% Prior
prior = cvReadImage('images/simpleTest1_prior.png');
%prior = imresize(prior, 0.5);
% Don't filter the prior, unless you really want to

% GT
groundTruth = cvReadImage('images/simpleTest1_GT.png');

%Perform the segmentation
% Img, prior, num_iter, wCV, wPrior, wEdge, wLength
seg = hybrid_method_withVFC(Img, prior, 150, 0, 0, 1, 0);

x = find(seg > 0);
y = find(groundTruth > 0);
dice = 2*length(intersect(x, y)) / (length(x) + length(y))

% results = []
% par = [0.1, 0, 1, 10, 100]
% for wCV = par
%     for wP = par
%         for wE = par
%             seg = hybrid_method(Img, prior, 150, wCV, wP, wE, 0);
%             x = find(seg > 0);
%             y = find(groundTruth > 0);
%             dice = 2*length(intersect(x, y)) / (length(x) + length(y));
%             
%             if dice > 0.5
%                 results(end+1,:) = [wCV, wP, wE, dice]
%             end
%         end
%     end
% end
