
function [tout1, tout2, tout3, tout4, tout5, hip_img, actual_reference, bestReferenceSlice, best_fitn, best_ref, fitn] ...
    = deformableModelInitialization(SOURCE_FOLDER,image_name,show_output,imageMatrix, ...
    extract_contours,ELAB_CONT_FOLDER,ELAB_FOLDER,BIGGEST_REF_IMAGE_SIZE, WORST_GLOBAL_FITNESS_FACTOR, REFERENCES, ...
    REF_CONT_FOLDER, type, HIPPO_REGION, MY_OFFSET, REF_FOLDER, f, out_dir_name, timestamp, registration_type)


[tout1, Iorig] = readImageToRegister(SOURCE_FOLDER,image_name,show_output,imageMatrix);

[tout2, res_img, I1,BIGGEST_REF_IMAGE_SIZE, orig_width_target] = extractExternalContour(extract_contours, ...
    show_output,ELAB_CONT_FOLDER,image_name,ELAB_FOLDER,SOURCE_FOLDER,BIGGEST_REF_IMAGE_SIZE);

[tout3,ORIG_HIPPO_REGION,CROP_HIPPO_REGION,T_MATRIX,fitnesses,siz_ref, P] = globalRegistration(REFERENCES, show_output, ...
    REF_CONT_FOLDER, I1, BIGGEST_REF_IMAGE_SIZE, type,HIPPO_REGION, MY_OFFSET, REF_FOLDER, res_img);

if strcmpi(registration_type,'globalAndLocal')
    [tout4, sum_variance, calculate_local, fitnesses, I1show] = ...
        localRegistration(fitnesses,CROP_HIPPO_REGION, T_MATRIX, REFERENCES, ...
        WORST_GLOBAL_FITNESS_FACTOR, REF_FOLDER, type, show_output, siz_ref, res_img, BIGGEST_REF_IMAGE_SIZE, f, P, ...
        out_dir_name, image_name);
else
    tout4 = 0.0;
    sum_variance = 0.0; %variance of selected rois
    calculate_local = fitnesses(1,:)<(min(fitnesses(1,:))*WORST_GLOBAL_FITNESS_FACTOR);
end;

[tout5, hip_img, actual_reference, bestReferenceSlice, best_fitn, best_ref, fitn] = ...
    bestReferenceSliceSelection(sum_variance,calculate_local, fitnesses, REFERENCES, ...
    ORIG_HIPPO_REGION, BIGGEST_REF_IMAGE_SIZE, show_output, Iorig, orig_width_target, out_dir_name, image_name, timestamp, I1show);



