function h=joint_h(image_1,image_2, levels)
% function h=joint_h(image_1,image_2)
%
% takes a pair of images of equal size and returns the 2d joint histogram.
% used for MI calculation
% 
% written by http://www.flash.net/~strider2/matlab.htm


rows=size(image_1,1);
cols=size(image_1,2);
N=levels;

image_1 = uint16(image_1);
image_2 = uint16(image_2);

h=zeros(N,N);

% for i=1:rows;    %  col 
%   i
% %   for j=1:cols;   %   rows
%     h1(image_1(i,:)+1,image_2(i,:)+1)= h1(image_1(i,:)+1,image_2(i,:)+1)+1;
% %   end
%   h1
% end
% 
for i=1:rows;    %  col 
  for j=1:cols;   %   rows
    h(image_1(i,j)+1,image_2(i,j)+1)= h(image_1(i,j)+1,image_2(i,j)+1)+1;
  end
end