
TEMPLATE = app

TARGET = cmd_ofeli

VERSION = 1.0.6

DEPENDPATH     += sources/core
DEPENDPATH     += sources/cmd
DEPENDPATH     += sources/vfc

CONFIG += link_pkgconfig
CONFIG -= qt webkit
PKGCONFIG += opencv
PKGCONFIG += fftw3
LIBS += -lfftw3_threads	
LIBS += -lboost_system
LIBS += -lboost_filesystem
LIBS += -lboost_serialization

QMAKE_CXXFLAGS_RELEASE -= -O2
QMAKE_CXXFLAGS_RELEASE += -O3
	
HEADERS += \
    activecontour.hpp \
    linked_list.hpp \
    hybrid.hpp \
    vfc.h

SOURCES += activecontour.cpp \
    linked_list.cpp \
    cmd.cpp \
    hybrid.cpp \
    vfc.cpp


CODECFORTR = UTF-8
CODECFORSRC = UTF-8

DESTDIR = build/target/
OBJECTS_DIR = build/obj/
MOC_DIR = build/moc/
RCC_DIR = build/rcc/

INCLUDEPATH = sources/core \
              source/vfc
