# ------------------------------
# Project created by QtCreator |
# ------------------------------

TEMPLATE = app

TARGET = Ofeli

VERSION = 1.0.6

DEPENDPATH     += sources/core
DEPENDPATH     += sources/gui

CONFIG += qt

HEADERS += \
    activecontour.hpp \
    filters.hpp \
    filters_rgb.hpp \
    hausdorff_distance.hpp \
    ac_withoutedges.hpp \
    geodesic_ac.hpp \
    ac_withoutedges_yuv.hpp \
    linked_list.hpp \
    imageviewer.hpp \
    pixmapwidget.hpp


SOURCES += activecontour.cpp \
    hausdorff_distance.cpp \
    filters.cpp \
    filters_rgb.cpp \
    ac_withoutedges.cpp \
    ac_withoutedges_yuv.cpp \
    geodesic_ac.cpp \
    main.cpp \
    linked_list.cpp \
    imageviewer.cpp \
    pixmapwidget.cpp


TRANSLATIONS = resources/$${TARGET}_fr.ts
CODECFORTR = UTF-8
CODECFORSRC = UTF-8

RESOURCES = resources/$${TARGET}.qrc

macx : ICON = resources/$${TARGET}.icns
win32 : RC_FILE = resources/$${TARGET}.rc

DESTDIR = build/target/
OBJECTS_DIR = build/obj/
MOC_DIR = build/moc/
RCC_DIR = build/rcc/

# statically linked version of Boost library
DEFINES = BOOST_THREAD_USE_LIB

INCLUDEPATH = external_libraries/boost_1_49_0 \
              sources/core \
              sources/gui
