
input_data_ext = '.mhd'
input_data_path = 'data/ROI_processed'

#Paths Ofeli
ofeli_cmd = '/home/valse/software/ofeli/valse/build/target/cmd_ofeli'
ofeli_input_data_ext = '.png'
ofeli_prior_data_ext = '.png'
ofeli_output_data_ext = '.png'
ofeli_validation_data_ext = '.png'
ofeli_validation_data_path = 'data/ground-truth'

validation_data_ext = '.mhd'
validation_data_path = 'data/ground-truth'
validation_label = 'overlap'
validation_program = '/home/valse/software/eaelastix/scripts/ComputeOverlap/ComputeOverlap'

prior_path = 'priors'

# Test Scenarios
image_name = ['1300018I05Rik_86','0610010D24Rik_103_26','1300018I05Rik_94','5430437P03Rik_107_26','reference12','Atrx_133_32','B230215L15Rik_129','reference15','Nmt1_140_34','reference13','Wbp7_110','Wars_109','Tubb3_114','Trem1_2800','reference14','3830406C13Rik_66','A030009H04Rik_117','Atp1b2_2725','Azin1_96','Camk2a_102','Camk2b_102','Camk2g_128_2248','Cd9_30','Cutl2_30','Gad1_104','Gapdh_93','Gfap_95_2307','Mbp_130','Slc17a7_120','Zim1_117']
referencesToUse = [14,10,15,10,12,12,16,15,14,13,15,16,16,15,14,16, 14, 17, 17, 15, 12, 17, 10, 11, 14, 12, 16, 17, 12, 16]
image_to_reference = dict(zip(image_name, referencesToUse))

#Some references have no ground truth
image_to_reference = dict( [ (k,v) for k,v in image_to_reference.iteritems() if not k.startswith("reference")] )

#scenarios = [ (img, 'reference{0}'.format(n) ) for img,n in image_to_reference.iteritems() ]
training_set = ['Zim1_117','Cutl2_30', 'Gfap_95_2307','Atrx_133_32']
training_set_ref = [16,11, 16,12]
scenarios = [ (img, 'reference{0}'.format(n) ) for img,n in dict(zip(training_set, training_set_ref)).iteritems() ]

# Number of runs per configuration per scenario
repetitions = 2
num_threads = 4

# Parameter values for the parameters being varied in a configuration
variable_parameters_pOne = {
}

variable_parameters_pTwo = {
}

# Parameter that are reported in the results table, in addition to the one in variable_params
reported_parameters = ['Optimizer']

params_file_name = 'parameters.txt'
results_file_name = 'results.csv'

variable_parameters_Ofeli = {
  "-lambda_in" : [ 1, 2, 5],
  "-lambda_out" : [ 1, 2, 5],
  "-weightCV" : [ 0, 1, 2, 5],
  "-weightPrior" : [ 0, 1, 2, 5],
  "-weightVFC" : [ 0, 1, 2, 5],
  "-gammaVFC" : [1, 1.5, 2, 2.5, 3],
}


