function [roi_img,hip_img] = roiElaboration(hip_img,timestamp,image_name,out_dir_name,show_output,image_side,typeOfROI)

%% ROI ELABORATION
%preprocess_roi is the new method based on histogram equalization and connected components
hip_img = im2double(hip_img);
%     hip1_filename = sprintf('%s/%s_localizationPre.png',out_dir_name,image_name);
%     imwrite(hip_img, hip1_filename,'png');

if strcmpi(typeOfROI,'preprocessing1')
    roi_img = preprocess_roi(hip_img,image_side, 3); 
elseif strcmpi(typeOfROI,'raw')
    roi_img = imresize(hip_img,[image_side image_side]);
elseif strcmpi(typeOfROI,'preprocessing1moreNoisy')
    roi_img = preprocess_roi(hip_img,image_side, 6); 
elseif strcmpi(typeOfROI,'likeLocalRegistration')
    roi_img = preprocess_roiLocal(hip_img, image_side);
end;
%     hip1_filename = sprintf('%s/%s_localizationPost.png',out_dir_name,image_name);
%     imwrite(roi_img, hip1_filename,'png');

if show_output >2
    roi_filename = sprintf('%s/%s_roi_ref_%s.png',out_dir_name,image_name,  timestamp);
    imwrite(roi_img, roi_filename,'png'); %save reduced and binarized ROI
end